# -- coding: utf-8 --

# efektiivne lahendus lõigupaaride läbivaatusega:
# kontrollib iga kahe lõigu jaoks, kas leidub ka
# kolmas, mis nendega kokku kolmnurga moodustab

# kasutab set andmetüüpi, millesse elementide lisamise
# ja nende sealt otsimise aeg on konstantne;
# lahenduse kogukeerukus on seega O(N^2)

# osaline lahendus, ei kontrolli lõikude kattumisi

import sys

n = int(sys.stdin.readline())
ll = set()
for i in range(n):
	x1, y1, x2, y2 = [int(_) for _ in sys.stdin.readline().split()]
	p1, p2 = (x1, y1), (x2, y2)
	ll.add((min(p1, p2), max(p1, p2)))

m = 0
for l1 in ll:
	for l2 in ll:
		if l1[0] != l2[0]:
			# need kaks lõiku ei moodusta vasakut alumist nurka
			continue
		lx = (min(l1[1], l2[1]), max(l1[1], l2[1])) 
		if lx not in ll:
			# kolmandat serva ei ole
			continue
		m += 1

print(m // 2)
