#include "testlib.h"

using namespace std;

const int MAX_N = 1e6;
const int MAX_M = 1e6;

int main (int argc, char **argv) {
  registerValidation(argc, argv);

  int n = inf.readInt(2, MAX_N, "n");
  inf.readSpace();
  int m = inf.readInt(1, MAX_M, "m");
  inf.readEoln();

  string s = inf.readToken();
  for (char c : s) {
    ensuref(c == '(' || c == ')', "Non-() detected!");
  }
  ensuref((int) s.size() == n, "String length does not match n!");
  inf.readEoln();

  for (int i = 0; i < m; i++) {
    int l = inf.readInt(1, n, "l");
    inf.readSpace();
    inf.readInt(l + 1, n, "r");
    inf.readEoln();
  }
  inf.readEof();
}
