#include <iostream>

using namespace std;

bool solve (const string &s, int l, int r) {
  int bal = 0;
  bool seen0 = false;
  for (int i = l; i < r; i++) {
    if (s[i] == '(') {
      bal++;
    } else {
      bal--;
    }

    if (bal < 0) {
      return false;
    }

    if (bal == 0 && i != r - 1) {
      seen0 = true;
    }
  }
  return seen0 && bal == 0;
}

int main () {
  ios::sync_with_stdio(false);
  cin.tie(0);

  int n, qc;
  cin >> n >> qc;

  string s;
  cin >> s;

  for (int i = 0; i < qc; i++) {
    int l, r;
    cin >> l >> r;
    l--;

    if (solve(s, l, r)) {
      cout << "JAH" << '\n';
    } else {
      cout << "EI" << '\n';
    }
  }
}
