# sisendi korrektsuse kontrollija

import sys

fi = open(sys.argv[1], 'rt')
fo = open(sys.argv[2], 'wt')

k = int(fi.readline().strip())
if 1 > k or k > 10**7:
	sys.exit('K out of range')
fo.write('{0}\n'.format(k))

n = int(fi.readline().strip())
if 1 > n or n > 10**5:
	sys.exit('N out of range')
fo.write('{0}\n'.format(n))

mmin, mmax = None, None
for i in range(n):
	m = int(fi.readline().strip())
	if 1 > m or m >= 2**63-k:
		sys.exit('M[{0}] out of range'.format(1 + i))
	fo.write('{0}\n'.format(m))
	if mmin is None or mmin > m:
		mmin = m
	if mmax is None or mmax < m:
		mmax = m

fi.close()
fo.close()

if len(sys.argv) > 3 and sys.argv[3] == '-v':
	if k <= 100 and n <= 100 and mmin >= 101 and mmax <= 9899:
		print('Subtask 1')
	else:
		print('Subtask 2')
