#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

void print(long long a, long long b) {
	if (a < b) {
		cout << a << ".." << b << "\n";
	} else {
		cout << a << "\n";
	}
}

int main() {
	int k, n;
	cin >> k;
	cin >> n;
	vector<long long> a(n);
	for (auto & x : a) {
		cin >> x;
	}
	sort(a.begin(), a.end());

	if (a[0] <= 1) {
		// nothing
	} else if (a[0] <= k) {
		print(1, a[0] - 1);
	} else {
		print(a[0] - k, a[0] - 1);
	}
	for (int i = 0; i + 1 < n; ++i) {
		long long d = a[i + 1] - a[i];
		if (d <= 1) {
			// nothing
		} else if (d <= 2 * k + 1) {
			print(a[i] + 1, a[i + 1] - 1);
		} else {
			print(a[i] + 1, a[i] + k);
			print(a[i + 1] - k, a[i + 1] - 1);
		}
	}
	print(a[n - 1] + 1, a[n - 1] + k);
}
