# -- coding: utf-8 --

# naiivne lahendus kõigi lõigukolmikute läbivaatusega;
# keerukus on O(N^3), jääb suuremates testides ajahätta

# osaline lahendus, ei kontrolli lõikude kattumisi

import sys

# kontrollib, kas kolm lõiku moodustavad kolmnurga
# ei kontrolli, et kolmnurk pole kõdunud
def kolmnurk(l1, l2, l3):
	if l1[0] == l2[0]:
		if l1[1] == l3[0] and l2[1] == l3[1]:
			return True
		if l1[1] == l3[1] and l2[1] == l3[0]:
			return True
	if l1[0] == l2[1]:
		if l1[1] == l3[0] and l2[0] == l3[1]:
			return True
		if l1[1] == l3[1] and l2[0] == l3[0]:
			return True
	if l1[1] == l2[0]:
		if l1[0] == l3[0] and l2[1] == l3[1]:
			return True
		if l1[0] == l3[1] and l2[1] == l3[0]:
			return True
	if l1[1] == l2[1]:
		if l1[0] == l3[0] and l2[0] == l3[1]:
			return True
		if l1[0] == l3[1] and l2[0] == l3[0]:
			return True
	return False

n = int(sys.stdin.readline())
ll = list()
for i in range(n):
	x1, y1, x2, y2 = [int(_) for _ in sys.stdin.readline().split()]
	ll.append(((x1, y1), (x2, y2)))

m = 0
for i1 in range(n):
	for i2 in range(i1):
		for i3 in range(i2):
			if kolmnurk(ll[i1], ll[i2], ll[i3]):
				m += 1

print(m)
