// random string, random queries
// probably will have "no" for almost all queries
// but it's good to have a couple of such random tests

#include "testlib.h"
#include <iostream>

using namespace std;

int main (int argc, char **argv) {
  registerGen(argc, argv, 1);

  int n = opt<int>("n");
  int m = opt<int>("m");

  cout << n << " " << m << '\n';
  for (int i = 0; i < n; i++) {
    if (rnd.next(2) == 0) {
      cout << "(";
    } else {
      cout << ")";
    }
  }
  cout << '\n';
  
  for (int i = 0; i < m; i++) {
    int l, r;
    do {
      l = rnd.next(1, n);
      r = rnd.next(1, n);
    } while (l == r);

    if (l > r) {
      swap(l, r);
    }
    cout << l << " " << r << '\n';
  }
}
