# sisendi korrektsuse kontrollija

import sys

fi = open(sys.argv[1], 'rt')
fo = open(sys.argv[2], 'wt')

n, m = [int(_) for _ in fi.readline().split()]
if 2 > n or n > 1e6:
	sys.exit('N out of range')
if 1 > m or m > 1e6:
	sys.exit('M out of range')
fo.write('{0} {1}\n'.format(n, m))

a = fi.readline().strip()
if len(a) != n:
	sys.exit('A length mismatch')
for c in a:
	if c not in '()':
		sys.exit('Invalid characters in A')
fo.write('{0}\n'.format(a))

for i in range(m):
	l, r = [int(_) for _ in fi.readline().split()]
	if 1 > l or l >= r or r > n:
		sys.exit('L[{0}], R[{0}] out of range'.format(1 + i))
	fo.write('{0} {1}\n'.format(l, r))

fi.close()
fo.close()

if len(sys.argv) > 3 and sys.argv[3] == '-v':
	if n * m <= 1e6:
		print('Subtask 1')
	else:
		print('Subtask 2')
